# Copyright (c) 2006 Red Hat, Inc. All rights reserved. This copyrighted material 
# is made available to anyone wishing to use, modify, copy, or 
# redistribute it subject to the terms and conditions of the GNU General 
# Public License v.2.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# Author: Greg Nichols
#
# The Report object packages and/or presents test results in text, rpm, or html form.
#

import sys

hashModule = None
try:
    hashModule = __import__('hashlib')
except:
    try:
        hashModule = __import__('md5')
    except:
        print("Error: could not find hash library")


def unit_test():
    print(hashModule)
    content = "Boo"
    m=hashModule.md5()
    m.update(content)
    digest = m.hexdigest()

    print("Digest test of '%s': %s ..." % (content, digest))
    if digest == '2e4d1b829d740c57ff602b7d3d8658a5':
        print("PASS")
        return 0
    else:
        print("FAILED")
        return 1

if __name__ == "__main__":
    sys.exit(unit_test())





