# Copyright (c) 2016 Red Hat, Inc. All rights reserved. This copyrighted material
# is made available to anyone wishing to use, modify, copy, or
# redistribute it subject to the terms and conditions of the GNU General
# Public License v.2.
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# Author: Greg Nichols

import sys

from rhcert.services.microservice import MicroService


class ValidKernels(MicroService):

    def __init__(self, product=None, environment=None, deferredCall=None):
        MicroService.__init__(self, environment, deferredCall)
        self.product = product
        self.getAll = False

    def getMethod(self):
        return "GET"

    def getURL(self):
        if self.getAll:
            return "playback/valid-kernels"

        return "playback/valid-kernels/%s" %self.product

    def getHeaders(self):
        return {"Content-Type": "application/json"}

    def getCacheFileName(self):
        return "valid-kernels.json"

if __name__ == "__main__":

    sys.exit(1)
